Subject: Re: [BUG] resolved deltas

From: Jeff King <[email-masked]>
Date: Thu, 28 Aug 2014 19:04:11 -0400

On Thu, Aug 28, 2014 at 06:15:18PM -0400, Jeff King wrote:

> As I implemented, I realized that even with the mutex, I really was just
> implementing compare_and_swap (and I wrote it that way to make it more
> obvious). So if we wanted to, it would be trivial to replace the
> "claim_delta" function with a true compare-and-swap instruction if the
> compiler and processor support it.

That's something like this on top:

diff --git a/builtin/index-pack.c b/builtin/index-pack.c
index ed9e253..1782a46 100644
--- a/builtin/index-pack.c
+++ b/builtin/index-pack.c
@@ -897,6 +897,10 @@ static int claim_delta(struct object_entry *delta_obj,
 		       enum object_type delta_type,
 		       enum object_type base_type)
 {
+#ifdef __GCC_HAVE_SYNC_COMPARE_AND_SWAP_4
+	return __sync_bool_compare_and_swap(&delta_obj->real_type, delta_type,
+					    base_type);
+#else
 	enum object_type old_type;
 
 	object_entry_lock();
@@ -906,6 +910,7 @@ static int claim_delta(struct object_entry *delta_obj,
 	object_entry_unlock();
 
 	return old_type == delta_type;
+#endif
 }
 
 static struct base_data *find_unresolved_deltas_1(struct base_data *base,

Though I guess gcc's __sync stuff is old, and the new C11 thing is
stdatomic.h. I guess we could support either if we can find the right
preprocessor macros (I am not even sure if the above is correct; the "4"
is for the size of the data type, but this is an enum, so we don't even
know what the right size is...).

However, the above doesn't seem to be any faster for me, so it may not
be worth the hassle.

-Peff